// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foxglove_msgs:msg/Grid.idl
// generated code does not contain a copyright notice
#include "foxglove_msgs/msg/detail/grid__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `frame_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `cell_size`
#include "foxglove_msgs/msg/detail/vector2__functions.h"
// Member `fields`
#include "foxglove_msgs/msg/detail/packed_element_field__functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
foxglove_msgs__msg__Grid__init(foxglove_msgs__msg__Grid * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  // frame_id
  if (!rosidl_runtime_c__String__init(&msg->frame_id)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  // column_count
  // cell_size
  if (!foxglove_msgs__msg__Vector2__init(&msg->cell_size)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  // row_stride
  // cell_stride
  // fields
  if (!foxglove_msgs__msg__PackedElementField__Sequence__init(&msg->fields, 0)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    foxglove_msgs__msg__Grid__fini(msg);
    return false;
  }
  return true;
}

void
foxglove_msgs__msg__Grid__fini(foxglove_msgs__msg__Grid * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // frame_id
  rosidl_runtime_c__String__fini(&msg->frame_id);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // column_count
  // cell_size
  foxglove_msgs__msg__Vector2__fini(&msg->cell_size);
  // row_stride
  // cell_stride
  // fields
  foxglove_msgs__msg__PackedElementField__Sequence__fini(&msg->fields);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

foxglove_msgs__msg__Grid *
foxglove_msgs__msg__Grid__create()
{
  foxglove_msgs__msg__Grid * msg = (foxglove_msgs__msg__Grid *)malloc(sizeof(foxglove_msgs__msg__Grid));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foxglove_msgs__msg__Grid));
  bool success = foxglove_msgs__msg__Grid__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
foxglove_msgs__msg__Grid__destroy(foxglove_msgs__msg__Grid * msg)
{
  if (msg) {
    foxglove_msgs__msg__Grid__fini(msg);
  }
  free(msg);
}


bool
foxglove_msgs__msg__Grid__Sequence__init(foxglove_msgs__msg__Grid__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  foxglove_msgs__msg__Grid * data = NULL;
  if (size) {
    data = (foxglove_msgs__msg__Grid *)calloc(size, sizeof(foxglove_msgs__msg__Grid));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foxglove_msgs__msg__Grid__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foxglove_msgs__msg__Grid__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foxglove_msgs__msg__Grid__Sequence__fini(foxglove_msgs__msg__Grid__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foxglove_msgs__msg__Grid__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foxglove_msgs__msg__Grid__Sequence *
foxglove_msgs__msg__Grid__Sequence__create(size_t size)
{
  foxglove_msgs__msg__Grid__Sequence * array = (foxglove_msgs__msg__Grid__Sequence *)malloc(sizeof(foxglove_msgs__msg__Grid__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = foxglove_msgs__msg__Grid__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
foxglove_msgs__msg__Grid__Sequence__destroy(foxglove_msgs__msg__Grid__Sequence * array)
{
  if (array) {
    foxglove_msgs__msg__Grid__Sequence__fini(array);
  }
  free(array);
}
