// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foxglove_msgs:msg/PointsAnnotation.idl
// generated code does not contain a copyright notice
#include "foxglove_msgs/msg/detail/points_annotation__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `points`
#include "foxglove_msgs/msg/detail/point2__functions.h"
// Member `outline_colors`
// Member `fill_color`
#include "foxglove_msgs/msg/detail/color__functions.h"

bool
foxglove_msgs__msg__PointsAnnotation__init(foxglove_msgs__msg__PointsAnnotation * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    foxglove_msgs__msg__PointsAnnotation__fini(msg);
    return false;
  }
  // type
  // points
  if (!foxglove_msgs__msg__Point2__Sequence__init(&msg->points, 0)) {
    foxglove_msgs__msg__PointsAnnotation__fini(msg);
    return false;
  }
  // outline_colors
  if (!foxglove_msgs__msg__Color__Sequence__init(&msg->outline_colors, 0)) {
    foxglove_msgs__msg__PointsAnnotation__fini(msg);
    return false;
  }
  // fill_color
  if (!foxglove_msgs__msg__Color__init(&msg->fill_color)) {
    foxglove_msgs__msg__PointsAnnotation__fini(msg);
    return false;
  }
  return true;
}

void
foxglove_msgs__msg__PointsAnnotation__fini(foxglove_msgs__msg__PointsAnnotation * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // type
  // points
  foxglove_msgs__msg__Point2__Sequence__fini(&msg->points);
  // outline_colors
  foxglove_msgs__msg__Color__Sequence__fini(&msg->outline_colors);
  // fill_color
  foxglove_msgs__msg__Color__fini(&msg->fill_color);
}

foxglove_msgs__msg__PointsAnnotation *
foxglove_msgs__msg__PointsAnnotation__create()
{
  foxglove_msgs__msg__PointsAnnotation * msg = (foxglove_msgs__msg__PointsAnnotation *)malloc(sizeof(foxglove_msgs__msg__PointsAnnotation));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foxglove_msgs__msg__PointsAnnotation));
  bool success = foxglove_msgs__msg__PointsAnnotation__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
foxglove_msgs__msg__PointsAnnotation__destroy(foxglove_msgs__msg__PointsAnnotation * msg)
{
  if (msg) {
    foxglove_msgs__msg__PointsAnnotation__fini(msg);
  }
  free(msg);
}


bool
foxglove_msgs__msg__PointsAnnotation__Sequence__init(foxglove_msgs__msg__PointsAnnotation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  foxglove_msgs__msg__PointsAnnotation * data = NULL;
  if (size) {
    data = (foxglove_msgs__msg__PointsAnnotation *)calloc(size, sizeof(foxglove_msgs__msg__PointsAnnotation));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foxglove_msgs__msg__PointsAnnotation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foxglove_msgs__msg__PointsAnnotation__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foxglove_msgs__msg__PointsAnnotation__Sequence__fini(foxglove_msgs__msg__PointsAnnotation__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foxglove_msgs__msg__PointsAnnotation__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foxglove_msgs__msg__PointsAnnotation__Sequence *
foxglove_msgs__msg__PointsAnnotation__Sequence__create(size_t size)
{
  foxglove_msgs__msg__PointsAnnotation__Sequence * array = (foxglove_msgs__msg__PointsAnnotation__Sequence *)malloc(sizeof(foxglove_msgs__msg__PointsAnnotation__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = foxglove_msgs__msg__PointsAnnotation__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
foxglove_msgs__msg__PointsAnnotation__Sequence__destroy(foxglove_msgs__msg__PointsAnnotation__Sequence * array)
{
  if (array) {
    foxglove_msgs__msg__PointsAnnotation__Sequence__fini(array);
  }
  free(array);
}
